/* Thingw Thin Gui Wrapper - www.kgo.de
 * Copyright (C) 2005 Klaus Gotthardt (info@kgo.de)
 * Thingw uses the Thinlet GUI toolkit - www.thinlet.com
 * from Robert Bajzat (rbajzat@freemail.hu)
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 * 
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
 * Lesser General Public License for more details.
 * 
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA */


import java.io.*;
import java.awt.*;
import java.util.*;

public class Thingw extends Thinlet {
String lineSep=System.getProperty("line.separator");
String fileSep=System.getProperty("file.separator");
String userHome=System.getProperty("user.home");
String newline="<nl>";
Object domNode=null;
Object selectedNode=null;
Object optionsPanel;
// String fileName[];
private Vector vFiles;
private Vector vdomNodes;
private Vector vtreeObjects;
boolean DEBUG=false;

public Thingw() throws Exception {
		add(parse("thingwgui.xml"));  // parse gui
		Object treeObject = find("tree1");
		String input = "thingw.xml";
		String input_home = userHome + fileSep + "thingw.xml";
		// domNode = parseDOM(input); // parse configuration
		// copy_source_file(input, input_home);
		// domNode = parseDOM(getClass().getResourceAsStream(input_home));
		// InputStream is = new FileInputStream(input_home);
		// domNode = parseDOM(new FileInputStream(input));
		//		domNode = parseDOM(getClass().getResourceAsStream("thingw.xml")); // parse configuration
if (DEBUG)	System.out.println (input_home);
		try {
			domNode = parseDOM(new FileInputStream(input_home));
// domNode = parseDOM(getClass().getResourceAsStream("thingw.xml"));
		} catch (Exception ex) {
			if (DEBUG)	System.out.println ("ex"+ex.toString());
			try {
				domNode = parseDOM(getClass().getResourceAsStream("thingw.xml"));
				copy_source_file(input, input_home);

			} catch (Exception ex2) {
					if (DEBUG)	System.out.println ("ex2"+ex2.toString());
			}

		}
		
		vdomNodes=new Vector();
		vtreeObjects=new Vector();
		iterateNodes(domNode, treeObject);
	
}



public void iterateNodes(Object domNode, Object treeObject) {
if (DEBUG)			System.out.println ("iterate");
  		int count;
		count = getDOMCount(domNode,"item");
		for (int i=0;i<count;i++) {    	
			Object commandObj = getDOMNode(domNode,"item",i);
			vdomNodes.addElement(commandObj);
			String commandtext=getDOMAttribute(commandObj,"text");
			if (DEBUG)	System.out.println ("commandtext " + commandtext);
			Object treeItem = create("node");
			setString(treeItem, "text", commandtext);
			add(treeObject, treeItem);
			vtreeObjects.addElement(treeItem);
		}

		count = getDOMCount(domNode,"node");
		for (int i=0;i<count;i++) {    	
			if (DEBUG)	System.out.println ("node"+ i);
			Object tree = getDOMNode(domNode,"node",i);
			String treetext=getDOMAttribute(tree,"text");
			Object node1 = create("node");
			setString(node1, "text", treetext);
			String expanded=getDOMAttribute(tree,"expanded");
			if (expanded==null || expanded.equals("true")) { 
				setBoolean(node1, "expanded",true);
			} else { 
				setBoolean(node1, "expanded",false);
			};
			add(treeObject, node1);
			if (DEBUG)	System.out.println ("treetext " + treetext);
			iterateNodes(tree, node1);
		}
}


 

public void save() {
	Frame frame = new Frame ();
	FileDialog f = new FileDialog(frame, "Save result as", FileDialog.SAVE);
	f.show();                        // Display the dialog and block.
	String dir=f.getDirectory();
	String filename = f.getFile();   // Get the user's response
	if (filename != null) {          // If user didn't click "Cancel".
	try {
		FileWriter out = new FileWriter(dir+filename);
		out.write(getString(find("result"),"text").trim());
 		out.close();
	} catch (
		IOException e) { System.out.println(e); }
	}
}


public void getFilename(String objectnumber) {
	if (DEBUG) System.out.println ("objekt "+objectnumber);
	Frame frame = new Frame ();
	FileDialog fdiag = new FileDialog (frame, "Select File",
	FileDialog.LOAD);
	fdiag.setVisible (true);
	String file = fdiag.getDirectory() + fdiag.getFile();
	if (DEBUG)	System.out.println (file);
	vFiles.setElementAt(file,Integer.parseInt(objectnumber));
	buildCommand();
}




public void buildCommand() {
			StringBuffer sb=new StringBuffer();
			int count;
			count = getDOMCount(selectedNode,"option");
			for (int i=0;i<count;i++) {    	
				String type = getDOMAttribute(getDOMNode(selectedNode,"option",i),"type");
				if (type.equals("checkbox")) {
					if (getBoolean(find(""+i),"selected")) { 
						String value = getDOMAttribute(getDOMNode(selectedNode,"option",i),"value");
						sb.append(subst(value,newline,"&&"));
					}
				} 
				if (type.equals("textfield") || type.equals("passwordfield")) {
					sb.append(" ");
					String quote="\"";
					String quoted = getDOMAttribute(getDOMNode(selectedNode,"option",i),"quoted");
					if (quoted==null || quoted.equals("false")) quote="";
					String value=quote+getString(find(""+i),"text")+quote;
					sb.append(subst(value,newline,"&&"));
				}
				if (type.equals("label")) {
					String value = getDOMAttribute(getDOMNode(selectedNode,"option",i),"value");
					sb.append(subst(value,newline,"&&"));
				} 
				if (type.equals("button")) {
					String value = getDOMAttribute(getDOMNode(selectedNode,"option",i),"action");
					if (value.equals("filedialog")|| value.equals("dirdialog")) {
						String quote="\"";
						String quoted = getDOMAttribute(getDOMNode(selectedNode,"option",i),"quoted");
						if (quoted==null || quoted.equals("false")) quote="";
						String file = quote+(String)vFiles.elementAt(i)+quote;
						if (DEBUG) System.out.println ("file "+file);
						sb.append(" "+file);
					}

				} 
			}
			setString(find("command"), "text", sb.toString());

			String bt=getDOMAttribute(selectedNode,"button");
			if (bt==null || bt.equals("true")) {} else {
				CmdExec();
			};
}


public void select1() {
	optionsPanel = find("optionsPanel");
	removeAll(find("optionsPanel"));
	setBoolean(find("command"),"visible",false);
	setBoolean(find("result"),"visible",false);
	setBoolean(find("startbutton"),"visible",false);
	vFiles=new Vector();
	for (int j=0;j<vtreeObjects.size();j++) {    	
		if (getSelectedItem(find("tree1"))==vtreeObjects.elementAt(j)) {
			selectedNode=vdomNodes.elementAt(j);
			setString(find("result"),"text",""); 
			int count;
			count = getDOMCount(selectedNode,"option");
			for (int i=0;i<count;i++) {    	
				vFiles.addElement(""); 
				Object node=getDOMNode(selectedNode,"option",i);
				String type = getDOMAttribute(node,"type");
 				if (DEBUG) System.out.println ("type "+type+i);
				//Object pan = create("panel");
				Object obj = create(type);

				setString(obj, "text", getDOMAttribute(node,"text"));

				if (type.equals("checkbox")) {
					String gr= getDOMAttribute(node,"group");
					setString(obj, "group", gr);
					boolean sel = false;

					String select=getDOMAttribute(node,"selected");
					if (DEBUG) System.out.println ("sel "+select);
					if (select==null) sel = false;
					else if (select.equals("true")) sel = true;
					else if (select.equals("false")) sel = false;
					setBoolean(obj, "selected", sel);
					setMethod(obj,"action", "buildCommand()" , obj, this);

				}
				if (type.equals("textfield") || type.equals("passwordfield")) {
					setMethod(obj,"action", "buildCommand()" , obj, this);
				}
				if (type.equals("button")) {
					setMethod(obj,"action", "getFilename(this.name)" , obj, this);
requestFocus(obj);

				}
				if (type.equals("label")) {
				}	

				boolean vis = true;
				String visible=getDOMAttribute(node,"visible");
					if (DEBUG) System.out.println ("vis "+visible);
					if (visible==null) vis=true;
					else if (visible.equals("true")) vis = true;
					else if (visible.equals("false")) vis = false;
					setBoolean(obj, "visible", vis);

				
				
				setString(obj, "name", ""+i);
				add(optionsPanel, obj);
			}

			buildCommand();

			String cl=getDOMAttribute(selectedNode,"commandline");
			if (cl==null || cl.equals("true")) { 
				setBoolean(find("command"),"visible",true);
			};

			String out=getDOMAttribute(selectedNode,"output");
			if (out==null || out.equals("true")) { 
				setBoolean(find("result"),"visible",true);
			};

			String but=getDOMAttribute(selectedNode,"button");
			if (but==null || but.equals("true")) { 
				setBoolean(find("startbutton"),"visible",true);
			} ;


			String bt=getDOMAttribute(selectedNode,"buttontext");
			if (bt==null) {
				setString(find("startbutton"),"text","   Start   ");
			} else { 
				setString(find("startbutton"),"text",bt);
			};

     			if (DEBUG) System.out.println (getString(find("command"),"text"));
		}
	}
}

Thread t;
public void CmdExec() {
	Runnable r = new Runnable() {
     		public void run() {
     			try {
     				CmdExec2();
			} catch (Exception e) {
				e.printStackTrace(); 
			}
        	} 
	};
	t = new Thread(r);
     	t.start();
		

} 




public void CmdExec2() {
	setString(find("message"),"text","working, please wait");
	String cmdline=getString(find("command"),"text");
	StringBuffer sb=new StringBuffer();
	String file = "";

	sb.append("");	
	try {
		String line;
		Process p = Runtime.getRuntime().exec(cmdline+file);
		BufferedReader input =  new BufferedReader (new InputStreamReader(p.getInputStream()));
		while ((line = input.readLine()) != null) {
       		// System.out.println(line);
			sb.append(line+lineSep);
       	}
		BufferedReader err =  new BufferedReader (new InputStreamReader(p.getErrorStream()));
		while ((line = err.readLine()) != null) {
       		// System.out.println(line);
			sb.append(line+lineSep);
       	}
		err.close();
	} catch (Exception err) {
		err.printStackTrace();
		sb.append(err.toString());
	}
	setString(find("result"),"text",(sb.toString())); 
	setString(find("message"),"text","ready");

}

private static String subst (String s, String search, String replace)  {
	StringBuffer s2 = new StringBuffer ();
	int i = 0;
	int j = 0;
	int sl = search.length();
	while (j > -1) {
		j = s.indexOf(search,i);
		if (j > -1)  {
			s2.append (s.substring(i,j));
			s2.append (replace);
			i = j + sl;
		}    
	}
	s2.append (s.substring(i,s.length()));
	return s2.toString();
}	// end subst

public boolean copy_source_file(String source, String destination){
        InputStream in1 = null;
        OutputStream out1 = null;
        
        try{
		
			in1 = this.getClass().getResourceAsStream(source);
//            in1 = this.getClass().getClassLoader().getResourceAsStream(source);
            File dest = new File(destination);
            if (dest.exists()==false) dest.createNewFile();
            out1 = new FileOutputStream(dest);
    
            // Transfer bytes from in to out
            byte[] buf = new byte[1024];
            int len;
            while ((len = in1.read(buf)) > 0) {
                out1.write(buf, 0, len);
            }
            out1.flush();
            
            return true;
        }
        catch (IOException e) {
           System.err.println("Error while copying a file\n Error message : " + e.getMessage());
           return false;
        }finally{
            try{
                in1.close();
                out1.close();
            }
            catch(IOException e){
                System.err.println("Error while copying a file\n Error message : " + e.getMessage());
 
            }
        }
}

public void exit() {
	System.exit(0); 
}


public static void main(String[] args) throws Exception { new FrameLauncher("Thingw - Thin GUI Wrapper", new Thingw(), 800, 600);
}


}